package example;

import java.io.FileOutputStream;

import jp.co.systembase.core.DataTable;
import jp.co.systembase.report.Report;
import jp.co.systembase.report.ReportPages;
import jp.co.systembase.report.data.ReportDataSource;
import jp.co.systembase.report.renderer.pdf.PdfRenderer;

// @\Tv y[W}
public class ExamplePage {

	public static void main(String[] args) throws Throwable {
		ReportPages pages;
		{
			Report report = new Report(ReadUtil.readJson("report/example_page1.rrpt"));
			report.fill(new ReportDataSource(getDataTable1()));
			pages = report.getPages();
		}

		{
			Report report = new Report(ReadUtil.readJson("report/example_page2.rrpt"));
			report.fill(new ReportDataSource(getDataTable2()));
			// Ō̃y[Wǉ܂
			pages.addAll(report.getPages());
		}

		// PDFo
		{
			FileOutputStream fos = new FileOutputStream("output/example_page.pdf");
			try{
				pages.render(new PdfRenderer(fos));
			}finally{
				fos.close();
			}
		}
	}

	private static DataTable getDataTable1(){
		DataTable ret = new DataTable();
		ret.setFieldNames("key", "name", "a", "b", "c");
		ret.addRecord().puts("1", "", "`P", "aa", "bb");
		ret.addRecord().puts("1", "", "`Q", "aa", "bb");
		ret.addRecord().puts("1", "", "`R", "aa", "bb");
		ret.addRecord().puts("1", "", "`S", "aa", "bb");
		ret.addRecord().puts("2", "", "`P", "aa", "bb");
		ret.addRecord().puts("2", "", "`Q", "aa", "bb");
		ret.addRecord().puts("2", "", "`R", "aa", "bb");
		ret.addRecord().puts("2", "", "`S", "aa", "bb");
		ret.addRecord().puts("2", "", "`T", "aa", "bb");
		ret.addRecord().puts("2", "", "`U", "aa", "bb");
		ret.addRecord().puts("2", "", "`V", "aa", "bb");
		ret.addRecord().puts("2", "", "`W", "aa", "bb");
		ret.addRecord().puts("2", "", "`X", "aa", "bb");
		ret.addRecord().puts("2", "", "`PO", "aa", "bb");
		ret.addRecord().puts("2", "", "`PP", "aa", "bb");
		ret.addRecord().puts("2", "", "`PQ", "aa", "bb");
		return ret;
	}

	private static DataTable getDataTable2(){
		DataTable ret = new DataTable();
		ret.setFieldNames("sum", "sum_all");
		ret.addRecord().puts("2", "16");
		return ret;
	}

}
